//import terrapin.*;
//use Loe's floating point version instead
import processing.pdf.*;

int XSIZE=int(3.6*297);
int YSIZE=int(3.6*210);

PFont font16, font32;
PGraphicsPDF pdf;

void setup() {
     noLoop();
     size(XSIZE,YSIZE);
     pdf = (PGraphicsPDF) beginRecord(PDF, "DRAGON_FLOAT.pdf");
    //this was tricky, thanks, Jun
}

class PPoint extends PVector {
      PPoint(float x, float y){
            super(x,y);
      }
}

void setPosition(Terrapin t, PPoint P){
     t.x = (P.x);
     t.y = (P.y);
}
PPoint getPosition(Terrapin t){
     return new PPoint(t.x,t.y);
}
void setRotation(Terrapin t, float theta){
     t.setRotation(theta);
}
float getRotation(Terrapin t){
      return int(t.getRotation());
}
   
//from rosettacode.org/wiki/Dragon_curve in logo:
//to dcr :step :length
//  make "step :step - 1
//  make "length :length / 1.41421
//  if :step > 0 [rt 45 dcr :step :length lt 90 dcl :step :length rt 45]
//  if :step = 0 [rt 45 fd :length lt 90 fd :length rt 45]
//end
 
//to dcl :step :length
//  make "step :step - 1
//  make "length :length / 1.41421
//  if :step > 0 [lt 45 dcr :step :length rt 90 dcl :step :length lt 45]
//  if :step = 0 [lt 45 fd :length rt 90 fd :length lt 45]
//end
//The program can be started using dcr 4 300 or dcl 4 300.

void dcr(Terrapin t, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        t.right(45);
        dcr(t,newstep, newlen);
        t.left(90);
        dcl(t,newstep, newlen);
        t.right(45);
     }
     if (step == 0){
        t.right(45);
        t.forward(newlen);
        t.left(90);
        t.forward(newlen);
        t.right(45);
     }
}

void dcl(Terrapin t, int step, float len){
     int newstep = step - 1;
     float newlen = len / 1.41421;
     if (step > 0){
        t.left(45);
        dcr(t,newstep, newlen);
        t.right(90);
        dcl(t,newstep, newlen);
        t.left(45);
     }
     if (step == 0){
        t.left(45);
        t.forward(newlen);
        t.right(90);
        t.forward(newlen);
        t.left(45);
     }
}


void draw() {
     fill(0);
     stroke(0);
     background(255);
     pdf.textMode(SHAPE);
     Terrapin t = new Terrapin(this);
     setPosition(t,new PPoint(400,300));
     setRotation(t,0);
     
     font16 = createFont("Comic Sans MS",16); 
     font32 = createFont("Comic Sans MS",16); 
     drwIntro();
     strokeWeight(3);
     t.setPenColor(0, 0, 0);
     float dim = 200.0;

     dcr(t, 4, 500);

    
     endRecord();
}

void drwIntro(){
     textFont(font32,32);
     text("Fractals and Turtles",200,50);
     textFont(font16,16);
     text("Dragon Curve"
         , 200, 75,700,200); 
}

void stop(){
     endRecord();
}

