//import terrapin.*;
//use Loe's floating point version instead
import processing.pdf.*;

int XSIZE=int(3.6*297);
int YSIZE=int(3.6*210);

PFont font16, font32;
PGraphicsPDF pdf;

void setup() {
     noLoop();
     size(XSIZE,YSIZE);
     pdf = (PGraphicsPDF) beginRecord(PDF, "KOCH_FLOAT.pdf");
    //this was tricky, thanks, Jun
}

class PPoint extends PVector {
      PPoint(float x, float y){
            super(x,y);
      }
}

void setPosition(Terrapin t, PPoint P){
     t.x = (P.x);
     t.y = (P.y);
}
PPoint getPosition(Terrapin t){
     return new PPoint(t.x,t.y);
}
void setRotation(Terrapin t, float theta){
     t.setRotation(theta);
}
float getRotation(Terrapin t){
      return int(t.getRotation());
}
   
void koch(Terrapin t, float size, int n){
     if (n > 0){
	koch(t, size/3, n-1);
	t.left(60);
	koch(t, size/3, n-1);
	t.right(120);
        koch(t, size/3, n-1);
	t.left(60);
	koch(t, size/3, n-1);
     }
     else t.forward(size); 
}

void draw() {
     fill(0);
     stroke(0);
     background(255);
     pdf.textMode(SHAPE);
     Terrapin t = new Terrapin(this);
     setPosition(t,new PPoint(400,200));
     setRotation(t,0);
     
     font16 = createFont("Comic Sans MS",16); 
     font32 = createFont("Comic Sans MS",16); 
     drwIntro();
     strokeWeight(3);
     t.setPenColor(0, 0, 0);
     float dim = 200.0;

     koch(t, dim, 0);
     t.right(60);
     koch(t, dim, 1);
     t.right(60);
     koch(t, dim, 2);
     t.right(60);
     koch(t, dim, 3);
     t.right(60);
     koch(t, dim, 4);
     t.right(60);
     koch(t, dim, 5);
    
     endRecord();
}

void drwIntro(){
     textFont(font32,32);
     text("Fractals and Turtles",200,50);
     textFont(font16,16);
     text("Koch Snow Flake"
         , 200, 75,700,200); 
}

void stop(){
     endRecord();
}

